%generator nahodnych cisel matice
    %Generator(N)
        %vygenerujUniformRP(a,b)
        %vygenerujNormRP(stredni hodnota, smerodatna aodchylka)
    
classdef Generator
    
    properties (SetAccess = 'private', GetAccess = 'private')
        N %rozmer ctvercove matice
    end % properties
    
    methods
    
        % Konstruktor - predani poctu iteraci do privatni promenne N  
        function obj = Generator(rozmerMatice) 
            obj.N = rozmerMatice;
        end

        % Generator nahodneho cisla unirmniho rozlozeni pravdepodobnosti
        function [unifRoz,unifRozB] = vygenerujUniformRP(obj,a,b) %a, b jsou okrajove body intervalu
            U = rand(obj.N,obj.N);
            unifRoz = a + (b - a) * U;   
            U = rand(obj.N,1);
            unifRozB = a + (b - a) * U; 
        end
        
        % Generator nahodneho cisla normalniho rozlozeni pravdepodobnosti   
        function normRoz = vygenerujNormRP(obj,stredniHodnota,smerodatnaOdchylka) %stredni hodnota, smerodatna odchylka
            U = rand(obj.N,obj.N);
            V = rand(obj.N,obj.N);
            normRoz = (sqrt(-2 * log(U)).* sin(2 * pi  * V)) * smerodatnaOdchylka + stredniHodnota; %vypocet norm. rozdeleni prav. z uniformniho
        end 
         
    end  % methods
end % class